[leetcode]Edit Distance @ Python


原題地址:https://oj.leetcode.com/problems/edit-distance/

題意:

Given two words word1 and word2, find the minimum number of steps required to convert word1 to word2. (each operation is counted as 1 step.)

You have the following 3 operations permitted on a word:

a) Insert a character
b) Delete a character
c) Replace a character

解題思路:這道題是很有名的編輯距離問題。用動態規划來解決。狀態轉移方程是這樣的:dp[i][j]表示word1[0...i-1]到word2[0...j-1]的編輯距離。而dp[i][0]顯然等於i,因為只需要做i次刪除操作就可以了。同理dp[0][i]也是如此,等於i,因為只需做i次插入操作就可以了。dp[i-1][j]變到dp[i][j]需要加1,因為word1[0...i-2]到word2[0...j-1]的距離是dp[i-1][j],而word1[0...i-1]到word1[0...i-2]需要執行一次刪除,所以dp[i][j]=dp[i-1][j]+1;同理dp[i][j]=dp[i][j-1]+1,因為還需要加一次word2的插入操作。如果word[i-1]==word[j-1],則dp[i][j]=dp[i-1][j-1],如果word[i-1]!=word[j-1],那么需要執行一次替換replace操作,所以dp[i][j]=dp[i-1][j-1]+1,以上就是狀態轉移方程的推導。

代碼:

class Solution:
    # @return an integer
    def minDistance(self, word1, word2):
        m=len(word1)+1; n=len(word2)+1
        dp = [[0 for i in range(n)] for j in range(m)]
        for i in range(n):
            dp[0][i]=i
        for i in range(m):
            dp[i][0]=i
        for i in range(1,m):
            for j in range(1,n):
                dp[i][j]=min(dp[i-1][j]+1, dp[i][j-1]+1, dp[i-1][j-1]+(0 if word1[i-1]==word2[j-1] else 1))
        return dp[m-1][n-1]

 


免責聲明!

本站轉載的文章為個人學習借鑒使用,本站對版權不負任何法律責任。如果侵犯了您的隱私權益,請聯系本站郵箱yoyou2525@163.com刪除。



 
粵ICP備18138465號   © 2018-2025 CODEPRJ.COM